' main SYN4MEN1  (SYN4.00)
' menu 1 for SYN4

DEFINT I-N: OPTION BASE 1

rem $INCLUDE: 'S4COMMON'
rem $INCLUDE: 'S4FUNCTN'

if not isyn4 then call notalone

kone=1
call setscreen(0)

dim nw(nphtype),sc1(nphtype),sc2(nphtype)

'---  functions for plotting
def fnip(y)=ipy-y*kscry/4*scl/(-(pext=0.0)-(pext<>0.0)*pext)
def fnit(i)=ipx+i*dt*xpixel
def fnix(x)=x+xctr
def fniy(y)=yctr+y*scratio

'--- some formats
varfm$=" "+fndform$(4,3)
fmyn$=fnaform$(40)+fnaform$(3)
fmm$=fnfform$(7,2)+fnaform$(3)+fnfform$(7,2)
fmmm$=fndform$(6,3)+fnaform$(3)+fndform$(6,3)
fmtau$=fniform$(5)+"("+fniform$(3)+")"

'-- setup first time except if parameter file exists
if not icont then 
  isorm=1             'set source number
 if not iparflg then
  gosub MODELIN       'starting model
  gosub CHINVPARS     'inversion parameters
 end if
end if

410 '---------- Main Menu
  icont=ktrue
  menu2on=kfalse:lnprompt=24
 call scbox(1,18,ktrue,"MAIN MENU AND CURRENT MODEL","Press O for full OPTION list")
   call scprint(3,2,"I/O file prefix  ")
   call scprint(4,2,"Source (subevent) number ")
   call scprint(5,2,"Number of time function elements (NTAU) =")
   call scprint(6,2,"Length of time function elements (TAU0) =")

 call s4stf (kfalse,tau0,isorm,ntau(),atau(),tam(), tcent, t95) ' get duration

  call scprint(8,2,"      Strike   Dip  Rake Depth  Dur  dTo Dist   Az  Moment  VAR:Unwtd   Wtd")
  call scprint(9,2,"Model ")
  call scprint(10,2,"Errors")
  call scprint(12,2,"VARIANCES Total")
   k=0
   for i=1 to nphtype
     if kphflag(i) then k=k+1: call scprint(12,20+(k-1)*9,fnkphlab$(i))
   next

  call scprint(13,2,"Data ")
  call scprint(14,2,"R/D %")
 call scprint(16,2,"T-test:")
 if istflag then
   call tstats(ns,avd,sdd,t)
   call scprint(16,10,"DOF="):call scprintv((0),(0),str$(ns-1))
   call scprint((0),(0)," Mean Dif= "):call scprintvfu((0),(0),fndform$(5,3),avd)
   call scprint((0),(0),"  SD Dif= "):call scprintvfu((0),(0),fndform$(5,3),sdd)
   call scprint((0),(0),"  t="):call scprintvfu((0),(0),fnfform$(5,2),t)
 else
   call scprintv(16,10,"OFF")
 end if

'-- now write variables

call setvarcol
 call scprint(3,19,"<"+FHDR$+">")
 call scprint(4,27,str$(isorm))
 call scprint(5,43,str$(NTAU(isorm)))
 call scprint(6,43,str$(TAU0))

 locate 9,8
 print using fnfform$(6,1); fndeg(sorpar(1,isorm));fndeg(sorpar(2,isorm));fndeg(sorpar(3,isorm));
 print using fnfform$(6,1); sorpar(4,isorm)+cthk;
 print using fnfform$(5,1); t95;
 for i= 5 to 6 : print using fnfform$(5,1); sorpar(i,isorm); : next
                 print using fnfform$(5,1); fndeg(sorpar(7,isorm));
 print using fndform$(6,3); tam(isorm);
 print using varfm$; varnowt*varcor;varres*varcor

 locate 10,8
   for i=1 to 4 : print using fnfform$(6,2); erpar(i,isorm); : next
   print using fnfform$(5,1); ert95(isorm);
   for i=5 to 6 : print using fnfform$(5,1); erpar(i,isorm); : next
   print using fnfform$(5,1); fndeg(erpar(7,isorm));
   print using fndform$(6,3); ermom(isorm)

 locate 13,7
   print using varfm$; vardat*varcor;
   for i=1 to nphtype
    if kphflag(i) then print using varfm$; datvar(i)*varcor;
   next

 locate 14,7
   if vardat<>0 then t=varres/vardat*100. else t=0
   t=fnamin(t,999)
   print using fnfform$(9,1); t;
   for i=1 to nphtype
    if datvar(i)>0 then t=resvar(i)/datvar(i)*100. else t=0
    t=fnamin(t,999)
    if kphflag(i) then print using fnfform$(9,1); t;
   next

klst$="abcdfilmopqrsvwxz"
call scprintc(20,1,"OPTIONS:")
call scprompt(20,10,"A-summary")
call scprompt(20,22,"M-model menu")
call scprompt(20,38,"C-inversion menu")
call scprompt(20,55,"S-screen plot")

call scprompt(21,10,"I-iterate")
call scprompt(21,22,"F-focal spheres")
call scprompt(21,38,"L-station menu")
call scprompt(21,55,"W-write .PRM file")

call scprompt(22,2,"Q-quit")
call scprompt(22,10,"P-plot menu")
call scprompt(22,22,"X-DOS shell")
call scprompt(22,38,"Z-setup menu")
call scprint(22,38,"#-event shown")
if nsor>1 then
  call scprompt(22,55,"#-event shown(1-"+fnstrnum$(nsor)+")")
  klst$=klst$+numlist$(1,nsor)
end if

it$=""
600  itimerow=2:itimecol=61
  ik=input1(lnprompt,1,"Enter KEY for option ",it$,kfalse,menu2on,ktrue,klst$)
  if ik=3 then it$="q" else if ik=27 then 410
   kval=val(it$)
   itimerow=0 ' turn off display of time
   ichoice=asc(it$)
   if fninlim(kval,1,nsor) then isorm = kval : goto 410
   if not fninlim(ichoice,97,122) then 600

if ichoice =  97  then chain SYNDIR$+"SYN4MEN2"        '-- A
if ichoice =  98  then chain SYNDIR$+"SYN4MEN2"        '-- B
if ichoice =  99  then gosub CHINVPARS                 '-- C
if ichoice = 100  then chain SYNDIR$+"SYN4MEN2"        '-- D
if ichoice = 102  then chain SYNDIR$+"SYN4MEN2"        '-- F
'if ichoice = 104  then gosub HELP                      '-- H
if ichoice = 105  then chain SYNDIR$+"SYN4IT"          '-- I
if ichoice = 108  then gosub STADMENU                  '-- L
if ichoice = 109  then gosub MODELIN                   '-- M
if ichoice = 111  then gosub MENU                      '-- O
if ichoice = 112  then chain SYNDIR$+"SYN4PLOT"        '-- P
if ichoice = 113  then call ENDCHECK:                  '-- Q
if ichoice = 114  then gosub REALIGN                   '-- R
if ichoice = 115  then gosub SEISPLOT                  '-- S
if ichoice = 118  then chain SYNDIR$+"SYN4MEN2"        '-- V
if ichoice = 119  then gosub S4WPARM                   '-- W
if ichoice = 120  then call  SHELLCOM                  '-- X
if ichoice = 122  then chain SYNDIR$+"SYN4MAIN"        '-- Z
GOTO 410

'********************************
'********  SUBROUTINES  *********
'********************************
'-------------------------------------------------------------------------
MENU:
call scclear
call scbox(1,21,ktrue,"MAIN MENU OPTIONS","Press Esc to return to MAIN MENU")
menu2on=ktrue:lnprompt=22
klst$="abcdfilmopqrsvwxz"
call scprint(3,3,"KEY    OPTION DESCRIPTION")
call scprompt(4,4,"A - Send solution summary information to file or printer")
call scprompt(5,4,"B - Generate arrival time data file")
call scprompt(6,4,"C - Change inversion parameters (INVERSION PARAMETER MENU)")
call scprompt(7,4,"D - Generate output .INV file of synthetics or residuals")
call scprompt(8,4,"F - Plot focal spheres and source time functions on screen")
call scprompt(9,4,"I - Iterate and generate synthetic seismograms")
call scprompt(10,4,"L - List and change seismogram weights, windows, polarity")
call scprompt(11,4,"M - Change model parameters (MODEL MENU)")
call scprompt(12,4,"P - Generate plot file for hardcopy (PLOT MENU)")
call scprompt(13,4,"Q - Quit program")
call scprompt(14,4,"R - Realign and adjust data window of seismograms")
call scprompt(15,4,"S - Plot seismograms on screen")
call scprompt(16,4,"V - View response functions and elementary seismograms")
call scprompt(17,4,"W - Write parameter file")
call scprompt(18,4,"X - Shell (run DOS commands)")
call scprompt(19,4,"Z - Change structure, TAU, data file, t* (return to SETUP MENU)")
call scprint(20,4,"# - Change source (subevent) displayed in menus")
if nsor>1 then
  call scprint((0),(0)," (range 1-"+fnstrnum$(nsor)+")")
  call scprintc(18,2,"#")
  klst$=klst$+numlist$(1,nsor)
end if
return 600

'-------------------------------------------------------------------------

MODELIN: '--- subroutine to change model


 call scclear
 a$="":itimerow = 2:itimecol = 61
 call scbox(1,20,ktrue,"MODEL MENU","Press Esc to exit")
 call scprint(3,2,"KEY OPTION                                CURRENT VALUE")
 call scprompt(4,3,"# - Event number")
 call scprompt(5,3,"E - Number of events")
 call scprompt(6,3,"S - strike angle (cwise from N)")
 call scprompt(7,3,"D - dip angle")
 call scprompt(8,3,"R - rake angle")
 call scprompt(9,3,"H - depth of source in km")
 call scprompt(10,3,"O - time offset from event 1")
 call scprompt(11,3,"X - distance offset from event 1")
 call scprompt(12,3,"Y - azimuth from event 1")
 call scprompt(13,3,"M - moment (N-m)")
 call scprompt(14,3,"N - # of STF elements")
 call scprompt(15,3,"A - amplitudes of STF elements (errors in parentheses):")

call setvarcol
 locate 4,43:print using fniform$(7);isorm;
 locate 5,43:print using fniform$(7);nsor;
 locate 6,43:print using fmm$;fndeg(sorpar(1,isorm));" +-";erpar(1,isorm)
 locate 7,43: print using fmm$;fndeg(sorpar(2,isorm));" +-";erpar(2,isorm)
 locate 8,43: print using fmm$;fndeg(sorpar(3,isorm));" +-";erpar(3,isorm)
 locate 9,43: print using fmm$;sorpar(4,isorm)+cthk;" +-";erpar(4,isorm)
 locate 10,43: print using fmm$;sorpar(5,isorm);" +-";erpar(5,isorm)
 locate 11,43: print using fmm$;sorpar(6,isorm);" +-";erpar(6,isorm)
 locate 12,43: print using fmm$;fndeg(sorpar(7,isorm));" +-";erpar(7,isorm)
 locate 13,40: print using fmmm$;tam(isorm);" +-";ermom(isorm)
 locate 14,43: print using fniform$(7);ntau(isorm)
 nl=0
   for i=1 to ntau(isorm)
     if (i mod 7) =1 then nl=nl+1 : locate 15+nl,3
     print using fmtau$; atau(i,isorm)*100;ertau(i,isorm)*100;
   next

  if input1(21,1,"Enter KEY for option ",a$,kfalse,ktrue,ktrue,"#esdrhoxymnaq"+numlist$(1,nsor))=27 then return
  kval=val(a$)

  if fninlim(kval,1,nsor) then isorm = kval : goto MODELIN

if fniquit(a$) then return

if a$="#" then
      input "Source number"; n
      if fninlim(n,1,nsor) then isorm=n

elseif a$="a" then
   print"Enter relative amplitudes for time function"
       for i=1 to ntau(isorm): input atau(i,isorm) : next
       call s4stf(kfalse,tau0,isorm,ntau(),atau(),tam(),tcent,t95)

elseif a$="d" then
      input "DIP         "; d: sorpar(2,isorm)=fnrad(d)

elseif a$="e" then
      input "Number of sources "; n
      if fninlim(n,1,nsormax) then nsor=n
       isorm=fnamin(isorm,nsor)

elseif a$="h" then
      input "SOURCE DEPTH in km"; d: d=d-cthk
      sorpar(4,isorm)=fnamax(d,0.1)

elseif a$="m" then
     input "MOMENT (N-m)"; t
     if t>0 then tam(isorm)=t

elseif a$="n" then
     input "NTAU"; n
       if not fninlim(n,1,ntaumax) then
         print "Invalid number"
       else
         ntau(isorm)=n
         call s4stf(kfalse,tau0,isorm,ntau(),atau(),tam(),tcent,t95)
       end if

elseif a$="o" then
     input "ORIGIN TIME OFFSET in s ";d : sorpar(5,isorm)=d
elseif a$="r" then
     input "RAKE        "; d: sorpar(3,isorm)=fnrad(d)
elseif a$="s" then
     input "STRIKE      "; d: sorpar(1,isorm)=fnrad(d)
elseif a$="x" then
     input "DISTANCE OFFSET in km ";d : sorpar(6,isorm)=d
elseif a$="y" then
     input "AZIMUTH OFFSET in degrees ";d : sorpar(7,isorm)=fnrad(d)
end if
goto MODELIN

'-------------------------------------------------------------------------
CHINVPARS:  '--- change inversion parameters

 call scclear
 a$="":itimerow = 2:itimecol = 62
 call scbox(1,21,ktrue,"INVERSION PARAMETER MENU","Press Esc to exit")
 call scprint(3,2,"KEY OPTION                             CURRENT VALUE")

call scprompt(4,3,"M - minimum % decrease in variance")

call scprompt(5,3,"P - positivity of STF enforced")
 if ipcflag then
   call scprint(6,7,"%tolerance")
   call scprint(7,7,"damping increment")
 end if

call scprompt(8,3,"I - matching")
call scprompt(9,3,"T - station t statistics calculated")
if istflag then call scprompt(10,3,"C - change reference station variance values for t-stats")
call scprompt(11,3,"K - calculate variance for 1 iter.")
call scprompt(12,3,"W - change seismogram weights")
call scprompt(13,3,"L - least squares damper")

call scprompt(15,3,"# - Source number")
call scprompt(16,3,"F - time function adjustment multiplier")
call scprint(17,3,"-------------- adjustment multipliers (0=fixed) ----------------------")

call scprompt(18,5,"S-strike"):call scprompt((0),18,"D-dip"):call scprompt((0),27,"R-rake")
call scprompt((0),36,"H-depth"):call scprompt((0),47,"O-Time ")
call scprompt((0),54,"X-distnce"):call scprompt((0),64,"Y-azimuth")
call setvarcol
 locate 4,43:print using fniform$(5); varmin
 locate 5,43:print using fnaform$(3);fnyesno$(ipcflag)
 locate 6,43:print using fniform$(5);cint(stfmin*100)
 locate 7,43:print using fnfform$(5,1);dampfac
 locate 8,43: if invflag then print "AMPLITUDE" else print "SHAPE"
 locate 9,43:print using fnaform$(3);fnyesno$(istflag)
 locate 11,43:print using fnaform$(3);fnyesno$(krmsc)
 locate 13,43:print using fnfform$(5,1);theta
 locate 15,43:print using fniform$(5);isorm
 locate 16,43:print using fnfform$(5,1);stfdamp(isorm)

locate 19,3:  for i=1 to 7 :print using fnfform$(10,1);damp(i,isorm); : next

 if input1(22,1,"Enter KEY for option ",a$,kfalse,ktrue,ktrue,_
      numlist$(1,nsor)+"sdrhoxyfm#ivklptwq")=27 then return
'   call inlet (kfalse, a$, klen, kval, kascii)
     if a$="" then goto CHINVPARS else kval=val(a$)
     itimerow=0
if kval>0 then isorm = kval : goto CHINVPARS

 if fniquit(a$) then return

 if a$="s" then input "  Strike adjustment multiplier (0 to fix) ";          damp(1,isorm)
 if a$="d" then input "  Dip adjustment multiplier    (0 to fix) ";          damp(2,isorm)
 if a$="r" then input "  Rake adjustment multiplier   (0 to fix) ";          damp(3,isorm)
 if a$="h" then input "  Depth adjustment multiplier  (0 to fix) ";          damp(4,isorm)
 if a$="o" then input "  Time offset adjustment multiplier  (0 to fix) ";    damp(5,isorm)
 if a$="x" then input "  Distance offset adjustment multiplier  (0 to fix) ";damp(6,isorm)
 if a$="y" then input "  Azimuth offset adjustment multiplier  (0 to fix) "; damp(7,isorm)
 if a$="f" then input "  STF adjustment multiplier ";                       stfdamp(isorm)
 if a$="m" then input "  Minimum percent decrease in variance "; varmin

if a$="#" then
  input "Source number"; n
  if fninlim(n,1,nsor) then isorm=n

elseif a$="i" then
  input "Inversion matching AMPLITUDE(1) or SHAPE(2)"; n
  if n=1 then invflag=ktrue else if n=2 then invflag=kfalse
  if invflag then varcor=1.0e8 else varcor=1.0
  if (not invflag) then normamp=ktrue

elseif istflag and a$="c" then
  input "Set reference model statistics to current model (1) or set to zero (2)"; n
    for i=1 to nsta
      if n=1 then refvar(i)=stavar(i) else refvar(i)=0
    next

elseif a$="k" then
  input "Calculate error statistics for single iteration (y/n) "; y$
  krmsc=fnkyes(y$)

elseif a$="l" then
  input "Enter least squares damper "; theta

elseif a$="p" then
  input "Source time function Positivity enforced (y/n) "; y$
   ipcflag=fnkyes(y$)
    if ipcflag then
     input "  Change tolerance and damping increment (y/n) "; y$
      if fnkyes(y$) then
       input "   positivity tolerance for ATAU in percent ";d
       if abs(d)<>0 then stfmin=-abs(d)/100.
       input "   damping increase increment (>1) ";d
        if d>1 then dampfac=d
      end if
    end if

elseif a$="t" then
  input "Calculate station t-test statistics ON (y/n) "; y$
  istflag=fnkyes(y$)

elseif a$="w" then
  gosub RESETWT

end if

 goto CHINVPARS

'-------------------------------------------------------------------------
RESETWT:   '--- adjust station weights

call scclear
call scbox(1,13,ktrue,"SEISMOGRAM WEIGHTING MENU","Press Esc to exit")
call scprint(2,2, "KEY  WEIGHT OPTION")
call scprompt(4,3, "1 - Reset ALL weights to 1.0")
call scprompt(5,3, "2 - Reset only NON-ZERO weights to 1.0")
call scprompt(6,3, "3 - Store current weights in temporary array")
call scprompt(7,3, "4 - Reset weights to those stored in temporary array")
call scprompt(8,3, "5 - Multiply weights of all seismograms of same type by same factor")
call scprompt(9,3, "6 - Scale weights to station azimuthal density")
call scprompt(10,3, "7 - Normalize so average weight = 1.0")
call scprompt(11,3, "8 - View and change weights on screen")

 a$=""
 if input1(14,1,"Enter KEY for option ",a$,kfalse,ktrue,ktrue,"12345678")=27 then return
   ic=val(a$)

 if (not fninlim(ic,1,8)) then return

 if ic=8 then gosub STADMENU

'--- get weighting factors for phases
 if ic=5 then
  cls
  for i=1 to nphtype
   if kphflag(i) then
      call scprintc(21,1,"Weight factor for "+ fnkphlab$(i)+" (0 to skip, <0 to set to zero) ")
      input sc
     sc1(i)=sc
     if sc=0 then sc1(i)=1
     if sc<0 then sc1(i)=0
   end if
  next
 end if

'-- sum all current weights
  if ic=7 then
   sumwt=0.0 : numwt=0
    for ista=1 to nsta
     if iflag(ista) and wt(ista)>0 and (not nodat(ista)) then 
       sumwt=sumwt+wt(ista) : numwt=numwt+1
     end if
    next
    if sumwt>0 then wfac=numwt/sumwt else wfac=1.0
  end if

'-- adjust weights according to choice
  for ista=1 to nsta

   if iflag(ista) and (not nodat(ista)) then 

     if ic=1 then wt(ista)=1.0
     if ic=3 then wt0(ista)=wt(ista)
     if ic=4 then wt(ista)=wt0(ista)

   if wt(ista)>0 then 

     if ic=2 then wt(ista)=1.0
     if ic=5 then wt(ista)=wt(ista)*sc1(kphtype(ista))
     if ic=7 then wt(ista)=wt(ista)*wfac

'--- adjust weight according to distribution of seismograms of a particular 
'--     phase in azimuth; 
'--  weight adjustment is inversely proportional to 
'--     sum of exp(-((difference in delta)/20.0) ^2)
'--  with the 20.0 in the denominator a station at 35 degrees away in azimuth
'--     will contribute <5% to weight factor 

      if ic=6 then
       azd=azd(ista) : iph=iph(ista)
         swt=0
        for j=1 to nsta
          if iflag(j) and (iph(j)=iph) then
             dis=abs(azd(j)-azd)
             dis = fnamin (dis, abs(360-dis) )
             swt=swt+exp(-(dis/20.0)^2)
          end if
        next j
         wt(ista)=wt(ista)/sqr(swt)
      end if

     end if
    end if
   next ista

goto RESETWT

'-------------------------------------------------------------------------
REALIGN:  '-------- realign or window ----------------
call scclear : input "Realign(0) or set window(1)"; k
 if not fninlim(k,0,1) then return
 if k=0 then kreal=ktrue else kreal=kfalse
 input "Realign/window automatically(0) or by hand(1)"; kr
if kr=1 and itf=0 then print "Synthetics not yet calculated": d$=input$(1): return

    if kreal and kr=0 then 
      gosub AREALIGN
    elseif not kreal and kr=0 then 
      gosub AWINDOW
    elseif kr=1 then 
      gosub HREALIGN
    end if
    call setscreen (0)
    return

'-------------------------------------------------------------------------
HREALIGN:  '-------- realign/window by hand -------
  input "Starting station number to realign/window"; ista
    if ista=0 then return
    imove=1

  if invflag then 
     input "Seismogram amplitudes normalized (y/n)"; y$ 
      if fnkansr(y$) then normamp=fnkyes(y$)
  end if

  call setscreen (kega)
  kd=1:ia1=0:ia2=0:it1=0:it2=0

4150 ' plot and realign
   if ista<1 then ista=1
   if ista> nsta then call scclear : return

 if not iflag(ista) or nodat(ista) then
     ista=ista+kd
     if ista<1 then kd=+1
     goto 4150
 end if

  ndatin=fnamin(2*nes(ista), ndat(ista))
  call s4synio(1,0,ista,ndatin,0,odat(),dext,datsq)      'get data
  call s4synio(1,1,ista,nes(ista)-1,0,ss(),spext,synsq)  'get synthetics

  ipx=ksrcx/16 : ipy=kscry/2
  xnd=(kscrx-ipx)/ndatin

'-- correct data for geometrical spreading
    for i=1 to ndatin : odat(i)=odat(i)*gcor(ista) : next

   if not normamp then
      pext=fnamax(spext,dext*gcor(ista))
      scl=1.3
   else
      scl=2.0
   end if

4151
 call scclear
 call scprintb(1,1,string$(80,"="))
 call scprintb(1,20," SYN4 ")
 call scprintc(1,58," (Press Esc to exit) ")

    ip2=ipf2(ista)

'-- plot synthetics
    if normamp then pext=synrms(ista)

if kega>1 and (kgrcol(kcolsyn)<>kgrcol(kcoldat)) then
  ix=ipx+xnd*ip2 : iy=fnip(ss(1)) : call scpoint (ix,iy,kgrcol(kcolsyn))
  for i=2 to nes(ista):ix=ipx+xnd*(i+ip2-1):iy=fnip(ss(i)):call scline1(ix,iy,kgrcol(kcolsyn),kfalse):next
else
  for i=1 to nes(ista):it=ipx+xnd*(i+ip2-1):ia=fnip(ss(i)):call sccircle (it,ia,kone,kgrcol(kcolbak)) : next
end if

'-- plot data
    if normamp then pext=datrms(ista)*gcor(ista)

  call scpoint(ipx,fnip(0),kgrcol(kcoldat))
  for i=1 to ndatin
   it=ipx+xnd*i : ia=fnip(odat(i))
   call scline1 (it,ia,kgrcol(kcoldat),kfalse)
  next
   a$=hypoc$
   osec=fnvalue(7,2)*3600+ fnvalue(9,2)*60 + fnvalue(11,3)/10.+ tstime(ista)

4152 '-- erase old window tics and put in new ones 
    call scline2(it1,ia1,it1,ia2,0,kfalse)
    call scline2(it2,ia1,it2,ia2,0,kfalse)

'-- get variance for alignment
      call chkbound(ista)
      gosub VARCALC     'get new VAR for station

it1=ipx+xnd*ip2:ia1=ipy+5:ia2=ipy-5 : call scline2(it1,ia1,it1,ia2,kgrcol(kcolbak),kfalse)
it2=ipx+xnd*(ip2+ninv(ista))        : call scline2(it2,ia1,it2,ia2,kgrcol(kcolbak),kfalse)

4155 '-- write out seismogram information
     call scprint(2,2,fnstanm$(ista))
     call scprint(2,6,fnkphlab$(kphtype(ista)))
     call scprint(2,10," Var=") : print using varfm$;stavar(ista)*varcor;
     print " T res=";
     print using fnfform$(5,2); (ipf2(ista)-1)*dt(ista)-thtime(ista);
      asec=osec+ (ipf2(ista)-1)*dt(ista) : call hrminsec(asec,i,j,p)
     print " Time=";i;":";j;":"; : print using fnfform$(5,2);p;
     locate 1,30 : if kreal then print " REALIGNING "; else print " WINDOWING ";

4160 '-- set cursor speed
  call setstep(imove)
  d$=str$(imove) : if imove<10 then d$=" "+d$
  call scprintc(nrowchar-1,1,"OPTIONS:   Left   Right   Fast   Slow   Change   Next   Previous  step="+d$)
  while inkey$<>"": wend  'empty buffer
  call inkey(d$)

  if fniquit(d$) or fniesc(d$) then call scclear :return

  if d$="n" then kd=+1 : ista=ista+1 : goto 4150
  if d$="p" then kd=-1 : ista=ista-1 : goto 4150
  if d$="c" then kreal=not kreal : goto 4155

  if d$="f" or fnmoveup(d$) then imove=imove+1 : goto 4160
  if d$="s" or fnmovedn(d$) then imove=imove-1 : goto 4160

  mleft=fnmovelt(d$) or d$="l"
  mright=fnmovert(d$) or d$="r"
  if mleft and kreal then ipf2(ista)=ipf2(ista)-imove : goto 4161
  if mright and kreal then ipf2(ista)=ipf2(ista)+imove : goto 4161
  if mleft and (not kreal) then ninv(ista)=ninv(ista)-imove : goto 4161
  if mright and (not kreal) then ninv(ista)=ninv(ista)+imove : goto 4161

 goto 4160

 4161
      if not kreal then goto 4152
      goto 4151

'-------------------------------------------------------------------------
AWINDOW: '---- window automatically
 call scclear
 call scbox(1,14,ktrue,"AUTOMATIC WINDOWING","Press Esc to exit")
 call scprint(5,3,"For each Phase-Data Type (PDT) enter TIME WINDOW in seconds to invert")
 call scprint(7,7,"TIME WINDOW <0 will set window to 0")
 call scprint(8,7,"TIME WINDOW =0 will skip PDT")

  for i=1 to nphtype
   if kphflag(i) then
      call scprint(10,5,"For "+fnkphlab$(i))
      locate 12,5: input " Enter TIME WINDOW ";a$
        if fniesc(a$) then return
        sc1(i)=val(a$)
      call scprint(12,25,"       ")
   end if
  next

   for ista=1 to nsta
    if wt(ista)>0 and (not nodat(ista)) and ninv(ista)>0 then
      n=sc1(kphtype(ista))/dt(ista)
      if n>0 then
       ninv(ista)=n
       call chkbound(ista)
      elseif n<0 then
       ninv(ista)=0
      end if
    end if
   next

return
'-------------------------------------------------------------------------
AREALIGN: '----automatic realignment by cross-correlation 

 call scclear
 call scbox(1,15,ktrue,"AUTOMATIC REALIGNMENT","Press Q to exit")
 call scprint(3,4,"Realignment by cross-correlation")
 call scprint(5,3,"For each Phase-Data Type (PDT) enter TIME WINDOW for realignment")
 call scprint(6,4,"and TOLERANCE, both in seconds")
 call scprint(8,6,"0 TIME WINDOW will skip PDT")
 ir=0

 for i=1 to nphtype
   if kphflag(i) then
      call scprint(11,3,"For "+ fnkphlab$(i))
      call scprint(12,3,string$(20,32))
      call scprint(13,3,string$(20,32))
      locate 12,3 : input "TIME WINDOW ";a$
        if fniquit(a$) then return
        sc1(i)=val(a$)
      locate 13,3: input "TOLERANCE   ";a$
        if fniquit(a$) then return
        sc2(i)=val(a$)
   end if
      if (not ir) then ir= (sc1(i)>0 and sc2(i)>0)
  next

'-- ir is the flag to see if any realignments to be done
if (not ir) then
 locate 17,3: 
 input "No realigning done; do you want to reset alignments to original (y/n) "; y$
  if fnkyes(y$) then
   for ista=1 to nsta : ipf2(ista)=ipf1(ista) :  next
   return
 end if
end if

   call scprint(17,3,"  Realigning ... ")
'-- realign
  for ista=1 to nsta
    if (not iflag(ista)) or nodat(ista) then 4380

     dt=dt(ista)
     k=kphtype(ista)
     if sc1(k)=0 or sc2(k)=0 then 4380

     ntol=cint(sc2(k)/dt)
     nreal=cint(sc1(k)/dt)

    if nreal<1 then 4380 
    erase odat,ss
    ip=ipf2(ista) 
    ipmax=fnamin(ipf1(ista)+ntol,ndat(ista)) 
    ipmin=fnamax(ipf1(ista)-ntol,1)

    call s4synio (1,0,ista,ndat(ista),0,odat(),amax,datsq)  'get data
    call s4synio (1,1,ista,nes(ista),0,ss(),amax,synsq)     'get synthetics

      summax=0
    for ir1=ipmin to ipmax
      ireal=ir1
      gosub XCOREL
      if sum>summax then summax=sum : ip=ir1
    next

4370  ipf2(ista)=ip
4375  call chkbound(ista)
    if istflag then gosub VARCALC

4380 next ista

   return
'========================================================================
XCOREL: 'cross-correlate NREAL points starting at data point IREAL, return SUM
     sum=0  
      if ireal<1 or nreal<1 then return
      ireal=ireal-1
      nr=fnamin(nreal,ndat(ista)-ireal)
     for i=1 to nr
      sum=sum+ss(i)*odat(i+ireal)
     next
return
'========================================================================
STADMENU: '-- print station info on screen and make changes

4715 ipg=1 : npages=int(nsta/20.1)+1

4720 call scclear
 call scbox(1,22,ktrue,"STATION DATA MENU","Press Esc to exit")
 call scprint(2,2,"No  Sta  Phase   Del    Az   TOA   Var      Flag   +/-  Po1   Po2 Window  Wt")

  for k=1 to 19
   ista=(ipg-1)*19+k : nk=k
   locate k+2,2 : gosub P1LINE
   if ista=nsta then goto 4795
  next

4795 irow=1 : icol=1
4797 call scprintc(irow+2, 43+(icol-1)*6, "->")
    call scprintc(23,2,"7-Next page 3-Prev page 6-Rght 4-Lft 8-Up 2-Dn (or arrows) C-change (or +/-)")
    while inkey$<>"":wend 'empty buffer
    call inkey(d$)
      if fniesc(d$) then gosub RESETFLG : return
    call scprintv(irow+2, 43+(icol-1)*6, "  ")

   if fnipagedn(d$) or d$="n" then
      if ipg<npages then ' gosub RESETFLG : return
      ipg=ipg+1 :goto 4720
      end if

   elseif fnipageup(d$) or d$="p" then
      ipg=ipg-1 : ipg=fnamax(1,ipg) : goto 4720

   elseif fnmovert(d$) or d$="r" then icol=icol+1
   elseif fnmovelt(d$) or d$="l" then icol=icol-1
   elseif fnmoveup(d$) or d$="u" then irow=irow-1
   elseif fnmovedn(d$) or d$="d" then irow=irow+1
   elseif fnmovehm(d$) then icol=1
   elseif fnmovend(d$) then icol=6

   elseif d$="c" or fniplus(d$) or fnminus(d$) then
       mc=(d$="c") : mp=fniplus(d$) : mm=fnminus(d$)

       if mc then call cline (23,1) : locate 23,1 : input " New value "; valin
       ista= (ipg-1)*19 + irow

       if icol=1 then
         if mc then iflag(ista)=-valin
         if mm or mp then iflag(ista)=not iflag(ista)
       elseif icol=2 then
         if mc then if abs(valin)=1 then ipol(ista)=valin
         if mm then ipol(ista)=-1
         if mp then ipol(ista)=1
       elseif icol=3 then
         if mc then ipf1(ista)=valin
         if mm then ipf1(ista)=ipf1(ista)-1
         if mp then ipf1(ista)=ipf1(ista)+1
         call chkbound(ista)
       elseif icol=4 then 
         if mc then ipf2(ista)=valin
         if mm then ipf2(ista)=ipf2(ista)-1
         if mp then ipf2(ista)=ipf2(ista)+1
         call chkbound(ista)
       elseif icol=5 then 
         if mc then ninv(ista)=valin/dt(ista)
         if mm then ninv(ista)=ninv(ista)-1
         if mp then ninv(ista)=ninv(ista)+1
         call chkbound(ista)
       elseif icol=6 then 
         if mc then wt(ista)=valin 
         if mm then wt(ista)=wt(ista)-.1
         if mp then wt(ista)=wt(ista)+.1
         wt(ista)=fnamax(wt(ista),0.0)
       end if
       locate irow+2,2 : gosub P1LINE
   end if

4800  irow=fnamax(irow,1)
       if irow>nk then irow=1 : icol=icol+1
       icol=fnxlimit(icol,1,6)
     goto 4797

'-------------------------------------------------------------------------
P1LINE:
'--- writes one line for seismogram data menu
   print using fniform$(2);ista;
   print using fnaform$(6); " "+fnstanm$(ista);
   print using fnaform$(6); " "+fnkphlab$(kphtype(ista));
   print using fnfform$(6,1);del(ista);azd(ista);fndeg(ptoa(ista));
   if nodat(ista) then print " No Data "; else print using varfm$; stavar(ista)*varcor;
   call setvarcol
   print using fniform$(6); -iflag(ista); ipol(ista); ipf1(ista); ipf2(ista);
   print using fnfform$(6,1); ninv(ista)*dt(ista);
   print using fnfform$(6,2); wt(ista)
   call settxtcol
return
'-------------------------------------------------------------------------
SEISPLOT: '-----------plotting seismograms on screen
cls
if itf=0 then kpsyn=kfalse

   call scprintc(2,1," Change screen plotting parameters (y/n)>")
   call inkey(y$)
   if fnkyes(y$) then gosub SCREENPLOT
ista=0 : scl=1.0
ioff=-iploff*kscry/20

'-- find max of data
    datext=0 : kdat=kfalse : tmax=0
    for i=1 to nsta
     if not nodat(i) then kdat=ktrue
     if itf=0 then gcor(i)=1.0    'GCOR not yet calculated
     if iflag(i) then 
       datext=fnamax(datext,abs(dext(i)*gcor(i)))
       tmax=fnamax(tmax,nes(i)*dt(i))
     end if
    next
    pext=datext

'-- if no data
 if not kdat then normamp=ktrue : kpdat=kfalse
 if not kpdat and not kpsyn then goto ENDSEIS

call setscreen(kega)

8070 nplt=0 : nplotx=npps/2 : nploty=2
     if npps=1 then nplotx=1: nploty=1
     if npix=0 then xpix=0.9*(kscrx)/(nplotx*tmax) else xpix=npix

for iipy = 1 to nploty
 ipy= kscry/(2*nploty) + (iipy-1)*kscry/2   'plots NPPS grams per screen
 iys= 1 +(iipy-1)*(nrowchar/2)

for iipx = 1 to nplotx             'in 2 rows of npps/2
 ipx=(iipx-1)*int(kscrx/nplotx)
 ixs=1+ int((iipx-1)*(ncolchar-1)/nplotx)
 ixs=fnxlimit(ixs,1,ncolchar-10)

  nplt=nplt+1

8135 ista=ista+1
   if ista>nsta then k=fninquit(ktrue) : goto ENDSEIS
   if not iflag(ista) then 8135
     dt=dt(ista) : k=kphtype(ista) : scl=phscl(k) : p$=fnkphlab$(k)
     xpixel=xpix
     if (ilpflag and fnishort(ista)) then xpixel=xpix*5.0 
   if scl<0 then 8135

   datsq=1.0 : synsq=1.0 : spext=0 : dext=0.

'-- get data
    nin=1
   if kpdat or (not nodat(ista)) then
     nin=fnamin(nes(ista)+ipf2(ista)+1,ndat(ista))
     call s4synio(1,0,ista,nin,0,odat(),dext,datsq)
   end if

'-- get synthetics
   if kpsyn then
     call s4synio(1,1,ista,nes(ista),0,ss(),spext,synsq)
   end if

'-- scale STF to 1st seismogram on screen
   if nplt=1 then 
      call scclear : npd=xpix : timax=60: gosub PLOTSTF
   end if

8270 s$=fnstanm$(ista)
     call scprint(iys,ixs, s$)
     call scprint(iys,ixs+5, p$)

'-- start of inversion window
    ip2=ipf2(ista)

'-- scale seismograms
   if kpdat then for i=1 to nin : odat(i)=odat(i)*gcor(ista) : next

'--- plot synthetics with line if color (KEGA) or dots if not
if kpsyn then 
    if normamp then pext=synrms(ista)

  if kega>1 and (kgrcol(kcolsyn)<>kgrcol(kcoldat)) then
    for i=1 to nes(ista)
     ix=fnit(i+ip2-1) : iy=fnip(ss(i))+ioff
     if i=1 then call scpoint (ix,iy,kgrcol(kcolsyn)) else call scline1(ix,iy,kgrcol(kcolsyn),kfalse)
    next
  else
      kcrad= 1 'fnamax(1,cint(kscry/300))
    for i=1 to nes(ista)
      ix0=fnit(i+ip2-1) : iy0=fnip(ss(i))+ioff
      if abs(ix0-ix1)>=4 or abs(iy0-iy1)>=2 then ix1=ix0 : iy1=iy0 : call sccircle (ix1,iy1,kone,kgrcol(kcoldat))
    next
 end if
end if

'--- plot data with solid line
if kpdat and (not nodat(ista)) then
    if normamp then pext=datrms(ista)*gcor(ista)

   call scpoint(fnit(kzero),fnip(kzero)-ioff,kgrcol(kcoldat))
   for i=1 to nin
     it=fnit(i): ia=fnip(odat(i))-ioff
     call scline1 (it,ia,kgrcol(kcoldat),kfalse)
   next
end if

'-- make tic marks for inversion window
  it=fnit(ip2):ia1=ipy+3:ia2=ipy-3
  call scline2(it,ia1,it,ia2,kgrcol(kcolbak),kfalse)
  it=fnit(ip2+ninv(ista))
  call scline2(it,ia1,it,ia2,kgrcol(kcolbak),kfalse)

   if fninquit(kfalse) then goto ENDSEIS
next iipx, iipy

   if ista<nsta and not fninquit(ktrue) then 8070
ENDSEIS: call setscreen(0) : return

'-------------------------------------------------------------------------
VARCALC: '-- calculate Variance for station ISTA

  stavar=0
   ip=ipf2(ista)-1
   ninv=ninv(ista)
   if ninv=0 then stavar(ista)=stavar : return

   synorm=1.0 : datnorm=1.0
    if not invflag then synorm=synrms(ista) : datnorm=datrms(ista)*gcor(ista)

  for i=1 to ninv
    resq=odat(i+ip)/datnorm-ss(i)/synorm
    resq=resq*resq
    stavar=stavar+resq
  next
  stavar(ista)=stavar/ninv
 return
'========================================================================
sub CHKBOUND (ista) static
'--------- check bounds on NINV, IPF1 and IPF2
shared ipf1(),ipf2(),ninv(),ndat(),nes()

      ipf1(ista)=fnamax(1,ipf1(ista))
      ipf1(ista)=fnamin(ipf1(ista),ndat(ista))
      ipf2(ista)=fnamax(1,ipf2(ista))
      ipf2(ista)=fnamin(ipf2(ista),ndat(ista))
      ninv(ista)=fnamin(ninv(ista),ndat(ista)-ipf2(ista))
      ninv(ista)=fnamax(ninv(ista),0)
      ninv(ista)=fnamin(ninv(ista),nes(ista))

end sub
'========================================================================
sub TSTATS (ns,avd,sdd,t) static
'-- statistics of Huang et al. JGR, 91, 579-598, 1986. (T test)
  shared nsta, stavar(), refvar(), iflag(), nodat(), varcor

  t=0 : ns=0 : sumy=0 : sumyd=0 : sumyd2=0 : avd=0 : sdd=0

  for i=1 to nsta
    if iflag(i) and (not nodat(i)) then
      yd= (stavar(i) - refvar(i)) * varcor
       sumy=sumy+stavar(i)*varcor
       ns=ns+1 
       sumyd=sumyd+yd 
       sumyd2=sumyd2+yd*yd
     end if
  next

 if ns>1 then avd=sumyd/ns: sdd=sqr( (sumyd2 - sumyd*sumyd/ns)/(ns-1) )
 if sdd<>0 and ns>0 then t=avd/(sdd/sqr(ns)) 
end sub
'========================================================================
sub hrminsec ( sectime, ihr, imin, secs ) static
  secs=sectime
  ihr = int(secs/3600.)
   secs=secs - ihr*3600.0
  imin=int(secs/60.)
   secs=secs - imin*60.
 end sub
'=================================================================
SCREENPLOT:

 call scbox(1,15,ktrue,"SCREEN PLOTTING MENU","Press Esc to exit")
 call scprint(2,2,"KEY OPTION")
 call scprint(2,60,"CURRENT VALUE")

 call scprompt(4,3,"P - plots per screen")
  call scprintv(4,60, str$(npps))

 call scprompt(5,3,"N - number of pixels per second (0 default)")
  call scprintv(5,60, str$(npix))

 call scprompt(6,3,"O - seismograms offset (otherwise overlapping)")
  call scprintv(6,60,fnyesno$(iploff))

 call scprompt(7,3,"D - plotting Data")
  call scprintv(7,60,fnyesno$(kpdat))

 call scprompt(8,3,"S - plotting Synthetics")
  call scprintv(8,60,fnyesno$(kpsyn))

 call scprompt(9,3,"A - amplitudes normalized")
  call scprintv(9,60,fnyesno$(normamp))

 call scprompt(11,3, "M - scaling factors")
     for i=1 to nphtype
         call scprint(12,6+(i-1)*8,fnkphlab$(i))
         call setvarcol
         locate 13, 6+(i-1)*8 : print using fnfform$(4,1); phscl(i);
         call settxtcol
     next

 a$=""
 if input1(16,1,"Enter KEY for option ",a$,kfalse,ktrue,ktrue,"pnodsamq")=27 then return
 if fniquit(a$) then return

' print
 if a$="p" then
   input "Number of seismograms plotted per screen (1 or even number; 2,4,6,..)";n
    if (int(n/2)=n/2 or n=1) then npps=n
    npps=fnamax(1,npps)

 elseif a$="n" then
   input "Seismogram plotting scale on screen, pixels per second (0 for default)"; n
    npix=fnamax(0,n)

 elseif a$="o" then
    y$="y":if iploff then y$="n"
    iploff= igetyesno((0),(0),"Seismograms offset in plotting",y$,kfalse)

 elseif a$="d" then
    y$="y":if kpdat then y$="n"
    kpdat=igetyesno((0),(0),"Observed seismograms plotted",y$,kfalse)

 elseif a$="s" then
    y$="y":if kpsyn then y$="n"
    kpsyn=igetyesno((0),(0),"Synthetic seismograms plotted",y$,kfalse)

 elseif a$="a" then
   if invflag then
     y$="y":if normamp then y$="n"
     normamp=igetyesno((0),(0),"Amplitudes normalized",y$,kfalse)
   else
     print "Inverting for shape requires amplitude normalization"
     input "Press any key "; d$
     normamp=ktrue
   end if

 elseif a$="m" then
      print "Scale factors  (<0 to skip phase, 0 for no change)"
     for i=1 to nphtype
      if kphflag(i) then
         print "   For "; fnkphlab$(i);
         input s
         if s<>0 then phscl(i)=s
      end if
     next
 end if
 goto SCREENPLOT
return
'==================================================================  
'HELP:
'call scbox(1,22,ktrue,"HELP SCREEN","")
'
'
'call scpause(25,3)
'return

'==================================================================
RESETFLG:
    for i=1 to 7 : kphflag(i)=0 : next
    for i=1 to nsta
     if iflag(i) then
      kphflag(kphtype(i))=ktrue
     end if
    next
'--- set all phase flags
   kplot(1) = (kphflag(1) or kphflag(3) or kphflag(4) or kphflag(6) or kphflag(7))
   kplot(2) = (kphflag(2) or kphflag(5))
   ilpflag  = (kphflag(1) or kphflag(2) or kphflag(4) or kphflag(5) or kphflag(7))
   ispflag  = (kphflag(3) or kphflag(6))
   igdsnflag = (kphflag(4) or kphflag(5) or kphflag(6) or kphflag(7))
return
'==================================================================  
sub setstep (imove) static
'-- set step for cursor motion
  if imove= 0 or imove=31 then imove=60
  if imove=21 or imove=59 then imove=30
  if imove=11 or imove=29 then imove=20
  if imove=19 then imove=10
  if imove=61 then imove=1
end sub
'==================================================================  
rem $INCLUDE: 's4auxpl'
rem $INCLUDE: 's4ptbax'
rem $INCLUDE: 's4stf'
'rem $INCLUDE: 's4synio'
rem $INCLUDE: 's4wparm'
'========================================================================

