' main SYN4MEN2  (SYN4.00)
' menu 2 for SYN4

DEFINT I-N: OPTION BASE 1

rem $INCLUDE: 'S4COMMON'
rem $INCLUDE: 'S4FUNCTN'

if not isyn4 then call notalone

dim nw(7)
def fnix(x)=x+xctr  'duplicate of fn in SYN$MEN1
def fniy(y)=yctr+y*scratio     'ditto

SELECT CASE ichoice
  CASE 97
    gosub PRSUM                     '-- A
  CASE 98
    gosub ATDFILE                   '-- B
  CASE 100
    gosub SYNFILE                   '-- D
  CASE 102
    gosub PLOTFPS                   '-- F
  CASE 118
    call  ESPLOT                    '-- V
  CASE ELSE
END SELECT

  chain SYNDIR$+"SYN4MEN1"
'-------------------------------------------------------------------------

PRSUM:  '--------- print summary

if outf$="" then d$=fhdr$+".sum" else d$=outf$
if inputn((0),(0),"Enter file name (Blank for "+fhdr$+".SUM, Esc to abort)",d$,ktrue,ktrue,ktrue,"a",25)=27 then return

 if len(d$)=0 then
     outf$=fhdr$+".sum"
 else
     outf$=fnaddext$(lcase$(d$),"sum")
 end if

    call cline(24,1)
    call scprint(24,1,"Writing file "+outf$+" and summary lines to SYN4FPS.HDR")

    open "o",8,outf$
    width #8, 100
nt=0

 ad$=date$+"   "+time$
 fo1$=fniform$(5)+"("+fniform$(3)+")"
 fo2$=fnfform$(8,2)+" ("+fnfform$(5,2)+")"
 fo3$=fndform$(6,3)+" ("+fndform$(6,3)+")"
 varfm$=" "+fndform$(4,3)

 print #8, "Earthquake file: ";FHDR$;"   ";ad$ : print #8,
 print #8, "Hypocenter Header" : print #8, tab(5); hypoc$
 print #8,
                                    
 print #8, "-- Source structure --" 
 print #8, "   Ztop      Vp      Vs     Rho"
 x=0: if wthk>0 then print #8, using fnfform$(8,2);x;alphw;betaw;rhow; : print #8,"w"
 for i=1 to nlyr
    print #8, using fnfform$(8,2); ztop(i)+wthk;alph(i);beta(i);rho(i);
    if i=1 and nlyr>1 then print #8, "c" else print #8, ""
 next
 if nlyr>1 then print #8, "c- complete response calculated for";nrevcom;"bounces"

print #8,
print #8, "-- Station Data --"
print #8," N Sta  FP-I PDT Po1 Po2 +/-   Win   Del    Az   TOA Tres   Wt   Var     DT   t* Filter  RefMag"

 for ista=1 to nsta
   dt=dt(ista)
   print #8, using fniform$(2); ista; 
   print #8, using fnaform$(6); " "+fnstanm$(ista);
   print #8, using fniform$(1);-iflag(ista); iph(ista); instin(ista); inst(ista);
   print #8, using fnaform$(4); fnkphlab$(kphtype(ista));
   print #8, using fniform$(4); ipf1(ista); ipf2(ista); ipol(ista);
   print #8, using fnfform$(6,1); ninv(ista)*dt; del(ista); azd(ista); fndeg(ptoa(ista));
   print #8, using fnfform$(5,1); dt*(ipf2(ista)-1)-thtime(ista); wt(ista);
    if nodat(ista) then print #8, " No Data "; else print #8, using varfm$; stavar(ista)*varcor;
   print #8, using fnfform$(5,2); dt; tstar(ista);
   print #8, using fnfform$(6,2); hpfilt(ista);
   print #8, using fniform$(8); refmag(ista)
   if wt(ista)>0 and iflag(ista) and ninv(ista)>0 then nw(kphtype(ista))=nw(kphtype(ista))+1
 next

print #8, 
print #8, "-- Phase Data --"
print #8, "Type  Num    Mag.   Time    ResVar DataVar    R/D %" 
for i=1 to nphtype 
   if kphflag(i) then
    print #8, using fnaform$(5); fnkphlab$(i); 
    print #8, using fniform$(4); nw(i); : nt=nt+nw(i)
    print #8, using fniform$(8); phmag(i);
    print #8, using fnfform$(8,2); phrlen(i);
      if datvar(i)>0 then r=resvar(i)/datvar(i) else r=0
    print #8, using varfm$; resvar(i)*varcor;datvar(i)*varcor;
    print #8, using fnfform$(7,2); r*100
   end if
next
    print #8,""
    if vardat=0 then vrvd=0 else vrvd=varres/vardat
    print #8, "Total";
    print #8, using fniform$(4);nt;
    print #8, "                ";
    print #8, using varfm$; varres*varcor; vardat*varcor; 
    print #8, using fnfform$(7,2); vrvd*100

print #8,
print #8,"Rupture Velocity, Azimuth, Plunge = ";
print #8, using fnfform$(8,2);vrupt;azrupt;plrupt
print #8, 

for isor=1 to nsor
   print #8, "-- Source number";isor;" --"
   call s4stf (kfalse,tau0,isor,ntau(),atau(),tam(), tcent, t95)

   str=sorpar(1,isor) : dip=sorpar(2,isor) : rk=sorpar(3,isor)
   call s4auxpl (str,dip,rk,strt,dipt,raket)
   call s4ptbax (str,dip,rk,paz,ppl,taz,tpl,baz,bpl)
   d0=sorpar(4,isor)+cthk

  a$=hypoc$ 
  ts = fnvalue(7,2)*3600 + fnvalue(9,2)*60 + fnvalue(11,3)/10 + sorpar(5,isor)
   ih=int(ts/3600.0)
   ts=ts - 3600.0*ih
   im=int(ts/60.0)
   ts = ts - 60.0*im
  print #8, "Time ";ih;"h";im;"m";fnfix(ts,1);"s    ";
   xlat = fnvalue(14,5)/100 + sorpar(6,isor)*cos(sorpar(7,isor))/111.19
   xlon = fnvalue(19,6)/100 + sorpar(6,isor)*sin(sorpar(7,isor))/111.19
  print #8, " Latitude ";fnfix(xlat,2);"  Longitude "; fnfix(xlon,2)

 print #8,"Source function elements:  TAU = ";TAU0;" NTAU = ";NTAU(ISOR)

  for i=1 to ntau(isor)
    print #8, using fo1$; atau(i,isor)*100; 2*ertau(i,isor)*100;
    if i mod 8 = 0 then print #8,
  next

 print #8,
 print #8, " Half-duration = ";fnfix(tcent,1);"   95% duration = ";
 print #8, using fo2$; t95; ert95(isor)
 print #8,
 print #8, "      Strike           Dip            Rake           Depth
 print #8, using fo2$; fndeg(sorpar(1,isor)); 2*erpar(1,isor);_
                       fndeg(sorpar(2,isor)); 2*erpar(2,isor);_
                       fndeg(sorpar(3,isor)); 2*erpar(3,isor);_
                       d0;2*erpar(4,isor)
 print #8, "        Moment             Or. Time        Distance        Azimuth
 print #8, using fo3$; tam(isor); 2*ermom(isor);
 print #8, using fo2$; sorpar(5,isor); 2*erpar(5,isor);_
                       sorpar(6,isor); 2*erpar(6,isor);_
                       fndeg(sorpar(7,isor)); 2*erpar(7,isor) 
 print #8, "Aux Pl Str,Dip    Paz    Ppl    Taz    Tpl    Baz    Bpl"
 print #8, using fnfform$(7,1); fndeg(strt);fndeg(dipt);fndeg(paz);_
             fndeg(ppl);fndeg(taz);fndeg(tpl);fndeg(baz);fndeg(bpl)
 print #8, ""
 gosub SUMLINE        'output summary lines
next isor

 close 8

return
'------------------------------------------------------------
SUMLINE:
'-------- print summary lines

  open "a",9,"SYN4FPS.HDR"
if isor=1 then print #9, fhdr$+" "+ad$

'--- output for ISC format
  f1$=mid$(hypoc$,1,6) : f2$=mid$(hypoc$,28,5)
  if len(f2$)<5 then f2$=f2$+string$(5-len(f2$),32)
  print #9, f1$;
  print #9, using fniform$(2);ih;im;
  print #9, using fniform$(3);ts*10;
  print #9, using fniform$(5);xlat*100;
  print #9, using fniform$(6);xlon*100;
  print #9, using fniform$(3);d0;
  print #9, f2$;
   iexp= int(fnalog10(tam(isor))) 
   vm  = int(tam(isor)/(10^(iexp-2)))
  print #9, using fniform$(3); vm;
  print #9, using fniform$(2); iexp;
  print #9, using fniform$(4); fndeg(str);
  print #9, using fniform$(3); fndeg(dip);
  print #9, using fniform$(4); fndeg(rk)

'---output table format
  print #9, f1$;
  print #9, using fniform$(3);ih;im;
  print #9, using fnfform$(5,1);ts;
  print #9, using fnfform$(8,2);xlat;
  print #9, using fnfform$(8,2);xlon;
  print #9, using fnfform$(6,1);d0; 2*erpar(4,isor);
  a$=f2$
  print #9, using fnfform$(4,1); fnvalue(1,2)/10;
  print #9, using fniform$(4); fnvalue(3,3);
     iexpr = int(fnalog10(2.0*ermom(isor)+0.1))
     vmr   = int(2.0*ermom(isor)/(10^(iexpr-2)))
  print #9, using fniform$(3); vm;
  print #9, using fniform$(2); iexp;
  print #9, using fniform$(3); vmr;
  print #9, using fniform$(2); iexpr;
  print #9, using fnfform$(5,1); t95;
  print #9, using fniform$(4); fndeg(str); 2*erpar(1,isor);
  print #9, using fniform$(3); fndeg(dip); 2*erpar(2,isor);
  print #9, using fniform$(4); fndeg(rk); 2*erpar(3,isor);
  print #9, using fniform$(4); fndeg(strt); fndeg(dipt);
  print #9, using fniform$(4); fndeg(paz); fndeg(ppl); fndeg(taz); fndeg(tpl); fndeg(baz); fndeg(bpl);
   for i=1 to nphtype :print #9, using fniform$(3); nw(i); : next
  print #9, using fnfform$(4,1); wthk;
  print #9, using varfm$; varres*varcor; 
  print #9, using fniform$(4); vrvd*100

  close 9

 return

'-------------------------------------------------------------------------
SYNFILE: ' make data file with synthetics or residuals
cls

if itf=0 then call schit("Synthetics not yet calculated."): return
  input "Enter prefix for .INV file to be written (CR to quit)";pf$
    if len(pf$)=0 then return
    if pf$=fhdr$ then
      print
      input " The input file will be overwritten, OK? (y/n) "; y$
      if not fnkyes(y$) then return
    end if
    pf$=fnaddext$(pf$,"inv")

  print
  input "    Writing Synthetics(0) or Residuals(1) "; kres
  if kres=1 then kres=ktrue else kres=kfalse

  print "Writing file ";pf$
  open "o",9,pf$  : print #9, hypoc$
  dform$=" "+fndform$(6,4)

for ista=1 to nsta
   if iflag(ista) and not (nodat(ista) and kres) then

9500 
    xmag0=refmag(ista)   '''  phmag(kphtype(ista))
    xc=1.0e4 * xmag(ista) / (xmag0*gcor(ista))

'--- setup for synthetics
   call s4synio(1,1,ista,nes(ista),0,ss(),sext,synsq)  'get synthetics
   kp=9 : nin=nes(ista) : n2=nin+8

'--- set up for residuals
 if kres then 
   sext=1.1/xc : nin=ndat(ista) : n2=nin

   call s4synio(1,0,ista,nin,0,odat(),amax,datsq)  'get data
   kp=ipf2(ista) : ipo=ipf2(ista)-1 

  for j=1 to nin
     jss=j-ipo
       if jss>0 then subtr=ss(jss) else subtr=0.0
     odat(j)=odat(j)*gcor(ista)-subtr
     sext=fnamax(sext,abs(odat(j)))
   next

 end if
  
'--- output station header line

 xo=0 : xt=tstime(ista)+thtime(ista)

     print #9, using fnaform$(4); mid$(fnstanm$(ista),1,4);
     print #9, using fniform$(1); iph(ista); instin(ista); inst(ista);
     print #9, using fnfform$(8,2); del(ista);azd(ista);
     print #9, using fniform$(8); xmag(ista);
     print #9, using fnfform$(8,2); xt;
     print #9, using fnfform$(5,1); wt(ista);
     print #9, using fniform$(5); kp;n2;
     print #9, using fniform$(8); sext*xc;
     print #9, using fnfform$(6,2); dt(ista); xo; hpfilt(ista)

if instin(ista)>0 then 
   print #9, insfile$(ista)
elseif fningdsn(ista) then
  nz=nzero(ista) : np=npole(ista)
  print #9, using fniform$(5); nz; np;
  print #9, using dform$; calcons(ista)

    nz1=indexzp(ista)-1
  for j=1 to 2*nz
    nz1=nz1+1
   print #9, using dform$; zeropole(nz1);
   if (j mod 8 =0) or j=2*nz then print #9,""
  next j

  for j=1 to 2*np
    nz1=nz1+1
   print #9, using dform$; zeropole(nz1);
   if (j mod 8 =0) or j=2*np then print #9,""
  next j
end if

  if not kres then
    s=0  'print row of zeroes
    for j=1 to 8 : print #9, using dform$; s; : next : print #9,
  end if

  for j3=1 to nin
    if kres then s=odat(j3) else s=ss(j3)
    print #9, using dform$; s*xc;
    if (j3 mod 8 = 0) or j3=nin then print #9, ""
  next

  end if

 next  ista
  close 9
 return

'========================================================================
ATDFILE: ' write arrival time file
input "File name for arrival time data (q to quit, CR for default)"; d$

 if len(d$)=0 then
     outf$=fhdr$+".atd"
 else
     if fniquit(d$) then return
     outf$=d$
 end if

  print "Writing file ";outf$
  open "o",1,outf$

  print #1, hypoc$

'-- origin time
   a$=hypoc$
   osec=fnvalue(7,2)*3600.+ fnvalue(9,2)*60. + fnvalue(11,3)/10.

   for ista=1 to nsta
    if (not nodat(ista)) then 
     print #1, using fnaform$(4); mid$(fnstanm$(ista),1,4);
     print #1, using fniform$(1); -iflag(ista);iph(ista);

'--- change format for output to print arrival time rather than travel time
     asec=osec+ + tstime(ista) + (ipf2(ista)-1)*dt(ista) 
     call hrminsec(asec,i,j,p)
     print #1, using fniform$(2); i;j;
     print #1, using fnfform$(5,2);p

'-- old format= travel time
'     print #1, using fnfform$(8,2); tstime(ista)+dt(ista)*(ipf2(ista)-1)

    end if
   next
  close 1
 return
'========================================================================
sub ESPLOT static
shared kphtype(), dt(), nes(), indexes(), nsta, gfxi$, drive$
shared kega, kscrx, kscry, ncolchar, nrowchar, scratio,kgrcol()
shared a$

nmax=500
redim tin(nmax), appin(nmax,2), tes(nmax), aes(nmax)
famp$=drive$+"amps.tmp"

if not ifopen("i",7,famp$,0,-1) then return
  nraf=0 : n0=1

for ista=1 to nsta
  call setscreen(kega)
  if fnpwave(ista) then nph=2 else nph=1
  if fnilong(ista) then dtinc=5 else dtinc=1
  dt=dt(ista)

  t0=(nes(ista)+1)*dt : app0=0
  tscale=((kscrx-10)/t0)/2.5

  line input #7, a$
    s$=fnvalue$(9,4)
  input #7, n
  for i=1 to n
    input #7, t, a1, a2
     if i<=nmax then
      tin(i)=t : appin(i,1)=a1 : appin(i,2)=a2
      app0=fnamax(app0, abs(a1))
      app0=fnamax(app0, abs(a2))
     end if
  next
  n=fnamin(n,nmax)
  if app0=0 then app0=1

kyoff=3/nrowchar*kscry

'--- plot ES
  lbl$=s$+fnkphlab$(kphtype(ista))+"  Crustal response functions and seismograms"
  call scprint(1,1,lbl$)
  locate 2,3:print " Maximum amplitude of response functions:";app0;
  call scprintc(nrowchar,ncolchar-37,"Enter Q to quit; any key to continue..")
'  locate nrowchar-1,ncolchar-37: print "Enter Q to quit; any key to continue";
  t$="Tics:"+str$(dtinc)+"sec"
  locate nrowchar-1,3: print t$;

for j=1 to nph
  if nph=1 then l$="sS" else if j=1 then l$="pP" else l$="sP"
   nc=ncolchar/2*(j-1)+1
  call scprint(4,nc+1,l$)

  iy0=((kscry-kyoff)/5)+kyoff : iy01=iy0
  yamp=(kscry-kyoff)/5
  ix0=(j-1)*kscrx/2+15

  call scline2 (ix0-10, kscry, ix0-10, kyoff, kgrcol(kcoldat), kfalse)

 for i=1 to n
   ix=ix0+tin(i)*tscale
   iy=iy0-yamp*appin(i,j)/app0
   call scline2 (ix, iy0, ix, iy, kgrcol(kcoldat), kfalse)
 next

 call s4tmpio (1, ista, j, nes(ista), aes(), gfxi$ )

 amax=0
 for k=1 to nes(ista)
   tes(k)=(k-1)*dt
   amax=fnamax(amax, abs(aes(k)))
 next
 if amax=0 then amax=1

  iy0=3*(kscry-kyoff)/5+kyoff
  ix=ix0+tes(1)*tscale : iy=iy0-yamp*aes(1)/amax

'-- plot seismogram
  call scpoint (ix, iy, kgrcol(kcolsyn))

 for i=2 to nes(ista)
  ix=ix0+tes(i)*tscale : iy=iy0-yamp*aes(i)/amax
  call scline1 (ix, iy, kgrcol(kcolsyn), kfalse)
 next i

for i=0 to t0 step dtinc
  ix=ix0+i*tscale
  call scline2 (ix, iy0-kscry/80, ix, iy0+kscry/80, kgrcol(kcolbak), kfalse)
next i

 next j
   d$=input$(1) : if fniquit(d$) then goto ESPEND

next ista

ESPEND: close 7 : call setscreen(0)
end sub
'========================================================================
PLOTFPS: '---------- plot equal area net and planes
 d$="1"
 if input1((0),(0),"P (1), SH (2) or SV (3) plotted?",d$,kfalse,ktrue,ktrue,"123")=27 then return
 kplot=val(d$)
 call setscreen(kega)
 call scprintb(1,1,string$(80,"="))
 call scprintb(1,36," SYN4   Focal spheres ")

 for isorc=1 to nsor
    isor= (isorc-1) mod 3 +1

    irad=kscrx/8 : npl=0 : xctr=kscrx/6+(isor-1)*kscrx/3 : yctr=kscry/2+20
    str=sorpar(1,isorc): dip=sorpar(2,isorc): rk=sorpar(3,isorc)
    strt=str : dipt=dip : raket=rk
    ix=fnix(0) : iy=fniy(0) : iyr=fniy(-irad): iyr1=fniy(-irad+10)
    call sccircle(ix,iy,irad,kgrcol(kcolsyn))
    call scline2(ix,iyr,ix,iyr1,kgrcol(kcolsyn),kfalse)

 for ista=1 to nsta
   if fninesc then goto ENDFPS
   if iflag(ista) then
     a=fnrad(azd(ista))
     call eaproj (irad, ptoa(ista), a, x, y) : y=-y
     ix4=fnix(x)+4 : iy2=fniy(y)+2
     ixm4=fnix(x)-4 : iym2=fniy(y)-2
    if fnpwave(ista) then
     call scline2(ix4,iy2,ixm4,iym2,kgrcol(kcolbak),ktrue)  'box for P
    else
     call scline2(ix4,iy2-2,ixm4,iy2-2,kgrcol(kcolbak),kfalse)  'plus sign for S
     call scline2(ix4-4,iy2,ix4-4,iym2,kgrcol(kcolbak),kfalse)
    end if
   end if
 next ista
 nc=(isor-1)*ncolchar/3+3 : nc=fnxlimit(nc,1,ncolchar)
 call scprint(2,nc,"Source") : print isorc;
 call scprint(3,nc,"Str ") : print cint(fndeg(strt));
 call scprint(4,nc,"Dip ") : print cint(fndeg(dipt));
 call scprint(5,nc,"Rake") : print cint(fndeg(raket));
 if ispflag and not ilpflag then dt=phdt(3) else dt=phdt(1)

      if kplot<2 then
          gosub PLOTP
          call scprint(6,nc,"NP 2")
          call scprint(7,nc,"Str ") : print cint(fndeg(strt));
          call scprint(8,nc,"Dip ") : print cint(fndeg(dipt));
      elseif kplot=2 then
          gosub PLOTSRAD
      end if
      gosub PLOTS

 if isor = 3 or isorc=nsor then
   npd=20 : timax=sorpar(5,nsor)+ntau(nsor)*tau0+5 : gosub PLOTSTF
   if isorc=nsor then call scpause(nrowchar-1,icol): goto ENDFPS
   if fninquit(ktrue) then goto ENDFPS
   call scclear
 end if

next isorc

ENDFPS: call setscreen (0): return
'-------------------------------------------------------------------------
PLOTP:
     call pltnodpl(strt,dipt,xctr,yctr,irad)
     call s4auxpl (str,dip,rk,strt,dipt,raket)
     call pltnodpl(strt,dipt,xctr,yctr,irad)
     return
'-------------------------------------------------------------------------
PLOTS: '---------- subroutine to plot radiation patterns

 sd=sin(dip): cd=cos(dip): s2d=sin(2*dip): c2d=cos(2*dip)
 ss=sin(rk): cs=cos(rk)
 if kplot=1 then v=alph2 else v=beta2
 if kplot=3 then iangstep=3 else iangstep=10

 for iang=1 to 89 step iangstep
    ang=fnrad(iang)
    rp=sin(ang)/v : vslo=sqr(1/(v*v)-rp*rp)
    dthet=iangstep/(sqr(2)*sin(ang/2))
    if fninquit(kfalse) then return

    for az= 0 to 360 step dthet
      a=fnrad(az)-str: sa=sin(a): ca=cos(a): s2a=sin(2*a): c2a=cos(2*a)

   if kplot<2 then                    '--- sign of P down
       a1=sd*cs*s2a-s2d*ss*sa*sa: a2=s2d*ss: a3=-cd*cs*ca+c2d*ss*sa
       e1=a1*rp*rp+a2*vslo*vslo: e2=2*a3*rp*vslo
       fsgn=sgn(e1+e2)
   elseif kplot=2 then                '--- sign of SH down
       a2=cd*cs*sa+c2d*ss*ca : a1=sd*cs*c2a-.5*s2d*ss*s2a
       fsgn=sgn(a1*rp + a2*vslo)
   elseif kplot=3 then                '---- sign  of SV up
       a1=sd*cs*s2a-s2d*ss*sa*sa: a2=s2d*ss: a3=-cd*cs*ca+c2d*ss*sa
       e3=(vslo*vslo-rp*rp)*a3: e4=rp*vslo*(a2-a1)
       fsgn=sgn(-(e3+e4)) 
   end if

     if fsgn>=0 then 
       azrad=fnrad(az)
       call eaproj(irad,ang,azrad,x,y) : y=-y
       call scpoint(fnix(x),fniy(y),kgrcol(kcolsyn))
     end if

 next az, iang
 return

'========================================================================
sub PLTNODPL (strt,dipt,xctr,yctr,irad) static
'-------------- plot P-wave nodal plane
 shared scratio,kgrcol()

     dipt=dipt-fnrad(.1)
     x=irad*cos(strt-pii/2)
     y=irad*sin(strt-pii/2)
     call scpoint(fnix(x),fniy(y),kgrcol(kcolsyn))

     for i=0 to 180 step 10
     d1=fnrad(i)+strt
     p=pii/2-atn(tan(dipt)*sin(fnrad(i)))
     call eaproj(irad,p,d1,x,y)
     call scline1 (fnix(x),fniy(-y),kgrcol(kcolsyn),kfalse)
     next
end sub
'========================================================================
PLOTSRAD:'-- subroutine to plot S radiation pattern
    n=0 : sd=sin(dip): cd=cos(dip): s2d=sin(2.*dip):
    c2d=cos(2.*dip) : ss=sin(rk): cs=cos(rk)

'-- singular cases:
    if dip=0 then
       ain=90 : az=fndeg(str-rk) : gosub PROJNET : ixt1=ix : iyt1=iy
       ain=-ain : gosub PROJNET
       call scline2(ixt1,iyt1,ix,iy,kgrcol(kcolsyn),kfalse)
       go to 3180
    elseif s2d=0 and cs=0 then
       ain=90 : az=fndeg(str)+90 : gosub PROJNET : ixt1=ix : iyt1=iy
       ain=-ain : gosub PROJNET
       call scline2(ixt1,iyt1,ix,iy,kgrcol(kcolsyn),kfalse)
       go to 3180
    elseif cd=0 and ss=0 then
       ain=90 : az=fndeg(str)+45 : gosub PROJNET : ixt1=ix : iyt1=iy
       ain=-ain : gosub PROJNET
       call scline2(ixt1,iyt1,ix,iy,kgrcol(kcolsyn),kfalse)
       az=fndeg(str)-45 : gosub PROJNET : ixt1=ix : iyt1=iy
       ain=-ain : gosub PROJNET
       call scline2(ixt1,iyt1,ix,iy,kgrcol(kcolsyn),kfalse)
       go to 3180
    elseif c2d=0 and cs=0 then
       ain=90 : az=fndeg(str) : gosub PROJNET : ixt1=ix : iyt1=iy
       ain=-ain : gosub PROJNET
       call scline2(ixt1,iyt1,ix,iy,kgrcol(kcolsyn),kfalse)
       az=fndeg(str)+90 : gosub PROJNET : ixt1=ix : iyt1=iy
       ain=-ain : gosub PROJNET
       call scline2(ixt1,iyt1,ix,iy,kgrcol(kcolsyn),kfalse)
       go to 3180
    end if
    
    notyet=ktrue : sgnold=999 : n=0
    azstep=1.0 : dz=-azstep

STARTSH: '--- start loop for radiation pattern
    dz=dz+azstep : if dz > 180. then 3180
    az=dz : gosub AMPLSH
    if a1=0 then  '--- special case : ain = 90
       if notyet then ain=90. : gosub PROJNET : goto 3120
       if a2 <>0 then ain=90.*sgnold : gosub PROJNET : goto 3120
       ain=-90. : gosub PROJNET : ixx=ix : iyy=iy
       ain=90. : gosub PROJNET
       call scline2(ixx,iyy,ix,iy,kgrcol(kcolsyn),kfalse)
       n=0 
       goto 3130
    end if
     
    ain=fndeg(atn(-a2/a1))
    gosub PROJNET
    fcn=-a2/a1
    sdfdaz=sgn(((-2*sd*cs*s2a-s2d*ss*c2a)*a2-(cd*cs*ca-c2d*ss*sa)*a1)/a1/a1)
    sdshdrp=sgn(a1*cos(fnrad(ain))-a2*sin(fnrad(ain)))
    if  notyet then 3115           '----  first time
    if sdfdaz=sgn(ain-ainold) then 3120        '--- check for discontinuity
       if sdfdazold<>sdfdaz and sdshdrpold=sdshdrp then 3120
         ixx1=ix : iyy1=iy : ain=90.*sdfdaz : gosub PROJNET
         n=n+1 
         if n=1 then call scpoint(ix,iy,kgrcol(kcolsyn)) else call scline1(ix,iy,kgrcol(kcolsyn),kfalse)
         n=0
         ain=-ain : gosub PROJNET
         call scline2(ix,iy,ixx1,iyy1,kgrcol(kcolsyn),kfalse)
         n=2
         goto 3130

3115 '--- first point, just move
         n=n+1 : call scpoint(ix,iy,kgrcol(kcolsyn))
         ix1=ix : iy1=iy
         goto 3130

3120 n=n+1 : if n=1 then call scpoint(ix,iy,kgrcol(kcolsyn)) else_
   call scline1(ix,iy,kgrcol(kcolsyn),kfalse)

3130 sgnold=sgn(ain) : ainold=ain : sdfdazold=sdfdaz : sdshdrpold=sdshdrp

    notyet=kfalse
    goto STARTSH

3180 return
'=================================================================
sub EAPROJ ( irad, ang, az, x, y) static
'    pii=3.1415926
    r2=irad*sqr(2)*sin(ang/2)
    x= +r2*cos(az-pii/2)
    y= -r2*sin(az-pii/2)
end sub
'=================================================================
PROJNET: ' find x,y for projection
  da1=fnrad(ain) : da2=fnrad(az)
  call eaproj(irad,da1,da2,x,y) : iy=fniy(-y): ix=fnix(x)
return
'-----------------------------------------------------------------------------
AMPLSH: '---- amplitudes for SH
 a=fnrad(dz)-str : sa=sin(a): ca=cos(a): s2a=sin(2.*a): c2a=cos(2.*a)
 a2=cd*cs*sa+c2d*ss*ca : a1=sd*cs*c2a-.5*s2d*ss*s2a
 f=a1*rp + a2*vsb
return
'========================================================================
sub hrminsec ( sectime, ihr, imin, secs ) static
  secs=sectime
  ihr = int(secs/3600.)
   secs=secs - ihr*3600.0
  imin=int(secs/60.)
   secs=secs - imin*60.
 end sub
'========================================================================
rem $INCLUDE: 's4auxpl'
rem $INCLUDE: 's4stf'
rem $INCLUDE: 's4ptbax'
'rem $INCLUDE: 's4synio'
'========================================================================

